function x =  lsitrn1(A,b,numitr)
%LSITRN1 Linear system analog least-squares iterative refinement for the full
%rank overdetermined system Ax = b. 
%x =  lsitrn1(A,b,numitr) refines iteratively a computed least 
%squares solution of Ax = b. numitr is the  user supplied 
%number of iterations.
%This is the linear system analog iterative refinement
%for a least squares solution.  For another iterative
%refinement algorithm see LSITRN2.
%This program calls the MATCOM program LSFRQRH. 
%see section 8.9 of the book
%of the book.
%input  : Matrix A, vector b, and integer numitr
%output : vector x

        [m,n] = size(A);
        xold = zeros(n,1);
        for e1 = 1:numitr
           r = b - A * xold;
           c = lsfrqrh(A,r);
           xold = xold + c;
        end; 
        x = xold;
