 	function [x] =  lssvd(A,b,tol)
%lssvd Least-squares solutions for the rank deficient problem using SVD
%x = lssvd(A,b) computes a least-squares solution x
%to the rank - deficient overdetermined system Ax = b using
%SVD Factorization of A.  
%This program implements Algorthim 8.5 of the book. 
%input  : Matrix A and vector b
%output : vector x

[u,s,v] = svd(A);
s
b = u'*b;
r = find(sort(diag(s),'descend')>=tol,1,'last'); % find the numerical rank of the matrix
for i = 1:r
	y(i) = b(i)/s(i,i);
end
m = length(diag(s));
for i  = r+1:m
	y(i) = rand();
end
x = v*y';


