function  x = minnmsvd(A,b)
%MINNMSVD Minimum norm least-squares solution to the full
%rank overdetermined system Ax = b using the SVD for 
%x = minnmsvd(A,b) computes the minimum norm least squares 
%solution x using the SVD of A.
%See section 8.7.3 of the book 
%input  : Matrix A and vector b 
%output : vector x
        
	[m,n] = size(A);
        y = zeros(n,1);
	[U,S,V] = svd(A);
        bprime = U' * b;
        r = 0;
        for i = 1:n
         if S(i,i) > 10^(-15)
          y(i) = bprime(i) / S(i,i);
         else
          y(i) = 0;
         end;
        end;
        x = V * y;
